//+------------------------------------------------------------------+
//|                                                       ZigZag.mq4 |
//|                                          Copyright  2008, Esosa |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Esosa"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_width1 5
#property indicator_color2 LawnGreen
#property indicator_width2 5

//---- indicator parameters
extern int ExtDepth=60;
extern int ExtDeviation=60;
extern int ExtBackstep=60;
extern int FastMA = 15;
extern int SlowMA = 30;
//---- indicator buffers
double ExtMapBuffer[];
double ExtLowBuffer[];
double ExtBuffer[];
double SignalBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer);
   SetIndexBuffer(1,SignalBuffer);
   //SetIndexEmptyValue(0,0.0);
  
 
//---- indicator short name
   IndicatorShortName("Esosa Price TOP BOTTOM("+ExtDepth+","+ExtDeviation+","+ExtBackstep+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    shift, back,lasthighpos,lastlowpos,index;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow,slope,Next;
   
//----
   for(shift=Bars-ExtDepth; shift>=0; shift--)
   {
      double Zig = iCustom(Symbol(),0,"ZigZag",ExtDepth,ExtDeviation,ExtBackstep,0,shift);
      ExtMapBuffer[shift]=EMPTY_VALUE;
      //ExtMapBuffer[shift]=Zig;
      if(Zig>0)
      {
         //CALCULATE SLOPE
         ExtMapBuffer[shift]=Zig;
         int bars = 0;
         Next = 0;
         for(int x=shift-1; x>=0; x--)
         {
            Next = iCustom(Symbol(),0,"ZigZag",ExtDepth,ExtDeviation,ExtBackstep,0,x);
            bars++;
            if(Next>0)
            {
               break;
            }  
         }   
         slope = (Next - Zig)/bars;  
      }
      if(Zig<=0&&Next>0)
      {
         ExtMapBuffer[shift]=ExtMapBuffer[shift+1]+slope;   
      }
   }
   for(shift=Bars-ExtDepth; shift>=0; shift--)
   {
      double MACD   = iMACD(Symbol(),0,FastMA,SlowMA,1,0,0,shift);
      SignalBuffer[shift]=EMPTY_VALUE;
      if((MACD>0)&&ExtMapBuffer[shift]!=0)
      {
         SignalBuffer[shift]=ExtMapBuffer[shift];
         
      }
   }
   return(0);
   }
//+------------------------------------------------------------------+